$! Link procedure 
$! (c) Alexey Chupahin  15-MAR-2021
$! alexey@vaxman.de alexeychupahin@gmail.com
$!
$!
$ SET NOON
$WRITE SYS$OUTPUT " "
$WRITE SYS$OUTPUT "Create PBZIP2 for OpenVMS  "
$WRITE SYS$OUTPUT "(c) Alexey Chupahin   CHAPG"
$WRITE SYS$OUTPUT " "
$! Checking architecture
$DECC = F$SEARCH("SYS$SYSTEM:DECC$COMPILER.EXE") .NES. ""
$    IF F$GETSYI("ARCH_TYPE").EQ.1 THEN CPU = "VAX"
$    IF F$GETSYI("ARCH_TYPE").EQ.2 THEN CPU = "Alpha"
$    IF F$GETSYI("ARCH_TYPE").EQ.3 THEN CPU = "I64"
$WRITE SYS$OUTPUT "Checking architecture 	...  ", CPU
$SHARED=0
$IF ( (CPU.EQS."Alpha").OR.(CPU.EQS."I64") )
$  THEN 
$	SHARED=64
$  ELSE
$	SHARED=32
$ENDIF
$IF (P1.EQS."STATIC") .OR. (P1.EQS."static") 
$ THEN 
$	SHARED=0
$	WRITE SYS$OUTPUT "Only static library will be configured"
$ENDIF
$!
$! Checking for BZIP2 library
$!
$ DEFINE SYS$ERROR _NLA0:
$ DEFINE SYS$OUTPUT _NLA0:
$ CC/OBJECT=TEST.OBJ/INCLUDE=(BZ2LIB) SYS$INPUT
      #include <stdlib.h>
      #include <stdio.h>
      #include <bzlib.h>
   int main()
     {
        printf("checking version bzip2 library:  %s\n",BZ2_bzlibVersion());
     }
$TMP = $STATUS
$DEASS SYS$ERROR
$DEAS  SYS$OUTPUT
$!WRITE SYS$OUTPUT TMP
$IF (TMP .NE. %X10B90001)
$  THEN
$       HAVE_BZIP2=0
$       HAVE_CHAPG_BZIP2=0
$       WRITE SYS$OUTPUT "Checking for correct bzip2 library ...   No"
$       WRITE SYS$OUTPUT "To get bzip2 archives support, please download"
$       WRITE SYS$OUTPUT "and install good library ported by Alexey Chupahin"
$       WRITE SYS$OUTPUT "from openvms clamav site "
$       WRITE SYS$OUTPUT "Or define logical BZ2LIB to the path where your library file LIBBZ2.OLB and BZLIB.H are located"
        WRITE SYS$OUTPUT "Your BZ2LIB should be built without /NAME=AS_IS"
$       WRITE SYS$OUTPUT ""
$       GOTO EXIT
$ENDIF
$DEFINE SYS$ERROR _NLA0:
$DEFINE SYS$OUTPUT _NLA0:
$!Testing for CHAPG BZIP2
$!
$LINK/EXE=TEST TEST,BZ2LIB:BZIP2/OPT
$TMP = $STATUS
$DEAS SYS$ERROR
$DEAS SYS$OUTPUT
$IF (TMP .NE. %X10000001)
$  THEN
$       HAVE_CHAPG_BZIP2=0
$       GOTO NEXT3
$  ELSE
$       HAVE_BZIP2=0
$       HAVE_CHAPG_BZIP2=1
$ENDIF
$IF (HAVE_CHAPG_BZIP2.EQ.1)
$  THEN
$       WRITE SYS$OUTPUT "Checking for CHAPG bzip2  library ...   Yes"
$       RUN TEST
$       GOTO NEXT4
$  ELSE
$ENDIF
$!
$NEXT3:
$DEFINE SYS$ERROR _NLA0:
$DEFINE SYS$OUTPUT _NLA0:
$LINK/EXE=TEST TEST,BZ2LIB:LIBBZ2/LIB
$TMP = $STATUS
$DEAS  SYS$ERROR
$DEAS  SYS$OUTPUT
$!
$!WRITE SYS$OUTPUT TMP
$IF (TMP .NE. %X10000001)
$  THEN
$       HAVE_BZIP2=0
$  ELSE
$       HAVE_BZIP2=1
$ENDIF
$IF (HAVE_BZIP2.EQ.1)
$  THEN
$       WRITE SYS$OUTPUT "Checking for correct bzip2 library ...   Yes"
$       RUN TEST
$  ELSE
$       WRITE SYS$OUTPUT "Checking for correct bzip2 library ...   No"
$       WRITE SYS$OUTPUT "To get bzip2 archives support, please download and install library ported by Alexey Chupahin from OpenVMS
pbzip2 site"
$       WRITE SYS$OUTPUT "Or define logical BZ2LIB to the path where your library file LIBBZ2.OLB and BZLIB.H are located"
$       WRITE SYS$OUTPUT "LIBBZ2.OLB should be compiled without /NAME=AS_IS"
$       WRITE SYS$OUTPUT
$       GOTO EXIT
$ENDIF
$NEXT4:
$!
$!
$ SET DEF [.'CPU']
$ CURRENT = F$ENVIRONMENT (""DEFAULT"")
$ SET DEF [-]
$ CLAM=CURRENT
$ OPEN/WRITE OUT PBZIP2$STARTUP.COM
$  WRITE OUT "$PBZIP2:==$",CLAM,"PBZIP2.EXE"
$ CLOSE OUT
$ WRITE SYS$OUTPUT "Linking PBZIP2 executables"
$ SET DEF [.'CPU']
$ CXXL/THREADS_ENABLE PBZIP2, BZ2STREAMSCANNER, ERRORCONTEXT, BZ2LIB:BZIP2/OPT
$ SET DEF [-]
$!
$ WRITE SYS$OUTPUT "" 
$ WRITE SYS$OUTPUT "***************************************************************************** "
$ WRITE SYS$OUTPUT "Link is completed."
$ WRITE SYS$OUTPUT "PBZIP2$STARTUP.COM is created. "
$ WRITE SYS$OUTPUT "This file setups all logicals needed. It should be executed before using PBZIP2" 
$ WRITE SYS$OUTPUT "***************************************************************************** "
$!
$EXIT:
$DEFINE SYS$ERROR _NLA0:
$DEFINE SYS$OUTPUT _NLA0:
$DEL TEST.C;*
$DEL TEST.OBJ;*
$DEL TEST.EXE;*
$DEL TEST.OPT;*
$DEAS SYS$ERROR
$DEAS SYS$OUTPUT
